float PARAMETRO = 50; // parâmetro de rede, é a distância entre os centros de átomos vizinhos

float RAIO = PARAMETRO/8; // raio dos elétrons

boolean roda; // variável de animação

Credito credito;

Par[][] par; // matriz de pares de posições

Positivo p;

boolean campo;

Botao aplicaCampo;

PFont f; // fonte do texto

PFont fatomo; // fonte dos elementos

///////////////////////////SETUP////////////////////////////////////////////////////////////////////
void setup(){
  size(600, 700);
  stroke(0, 0, 255);
  smooth();  
  par = new Par[8][15];
  
  //iniciamos os pares de posições
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 15; j++){
      if(j % 2 == 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.5), PARAMETRO*(j*.5 + 1.5) , "HORIZONTAL");
      else if(j % 2 != 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.0), PARAMETRO*(j*.5 + 1.5) , "VERTICAL");
      par[i][j].i = i;
      par[i][j].j = j;
  }

  //iniciamos os portadores de carga (positivos e/ou negativos)
  
  p = new Positivo(par[2][2].p2.x, par[2][2].p2.y, par[2][2], par[2][2].p2, par[3][3], par[3][3].p1);
  
 roda = false;
 //roda = true;
  
  f = loadFont("CourierNewPS-BoldMT-28.vlw"); 
  
  fatomo = createFont("Calibri-Bold-18.vlw", 18);
  
  credito = new Credito();
  
  aplicaCampo =  new Botao(17*width/20, par[4][9].ypos + width/10, width/10, 18, "APLICAR");
  
  //definimos se há ou não campo elétrico
  campo = false;
}

////////////////////////////////DRAW/////////////////////////////////////////////////////////////////
void draw(){
  background(255); 
  
  escreveTexto();
  
  pushMatrix();
  translate(0, height/16);
  desenhaAtomos();
  
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 15; j++){
      if(j % 2 != 0 || i < 7)
        par[i][j].display();
    }
    
  p.display();  
  desenhaCampo(17*width/20, par[4][9].ypos - height/12);
  popMatrix();
    
  if(roda == true){
    conduz();
  }
  
  botaoDisplay();
  credito.display();
}


////////////////////////////////FUNÇÔES/////////////////////////////////////////////////////////////////////
void escreveTexto(){
  textAlign(CENTER);
  textFont(f, 38);
  fill(100);
  text("Dopagem 'P'", width/2, height/12); //título
  
  textFont(f, 13);
  if(!roda)
    text("  Clique em qualquer lugar para iniciar a animação  ", width/2, height/8);
  
  text("Quando adicionamos ao semicondutor uma impureza substitucional com\n" + 
       "um número menor de elétrons na camada de valência, algumas ligações\n" + 
       "covalentes ficam deficientes em elétrons.\n\n" + 
       "Estas deficiências são chamadas de ‘buracos eletrônicos’,\n" + 
       "e consistem em portadores de cargas positivas.\n\n" +
     //  "O processo descrito é chamado de ‘dopagem do tipo p’.\n" + 
       " Acima, ilustramos a dopagem tipo 'P' do silício (Si) pela\n" + 
       "inserção de um átomo de boro (B) na estrutura cristalina do Si.\n\n" +
       "Altere a atuação do campo elétrico, com movimentos do mouse,\n" + 
       "e veja como o buraco eletrônico age na condução elétrica.",
       width/2, 35*height/48);
  
  
}

void desenhaAtomos(){
  textFont(fatomo, 18);
  textAlign(CENTER);
  stroke(0, 0, 255);
  for(int i = 0; i < 7; i++)
    for(int j = 0; j < 14; j++)
      if(j%2 == 0){        
        fill(255);
        ellipse(par[i][j].xpos, par[i][j+1].ypos, PARAMETRO/2, PARAMETRO/2);
        fill(0, 0, 255);
        text("Si", par[i][j].xpos, par[i][j+1].ypos + 6);
      }
  
  if(roda)    
    stroke(0, 0, 255);
  else
    stroke(0, 180, 0);
    
  fill(255);
  ellipse(par[2][2].xpos, par[2][3].ypos, PARAMETRO/2, PARAMETRO/2);
  
  if(roda)
    fill(0, 0, 255);
  else
    fill(0, 180, 0);
    
  text("B", par[2][2].xpos, par[2][3].ypos + 6); 
}
  

void conduz(){
  
  float campoX = (mouseX - /*width/2*/ par[4][9].xpos + PARAMETRO/2)*2.0/PARAMETRO;
  if(abs(campoX) < 1)
    campoX = 1;
  float campoY = (mouseY - /*height/2*/par[4][9].ypos)*2.0/PARAMETRO;
  if(abs(campoY) < 1)
    campoY = 1;
  
  if(p.k == 1){
    
    float r = random(-1, 1);
    float sinal = (abs(r))/r;
    int i = p.pproximo.i;
    int j = p.pproximo.j;    
   
    if(p.pproximo.direcao == "HORIZONTAL"){
      
      if(campo == true)
        r = random(min(campoX, -1),max(campoX, 1));
      else
        r = random(-1, 1);
      
      sinal = (abs(r))/r;
      
      if( sinal > 0 ){           //     sinal positivo -> desloca para a direita
        if(i == 7) 
          i = 0;                 //     sinal negativo -> desloca para a esquerda (i se mantém, mas j muda)
        else
          i = i + 1;
      }
        
      if(campo == true)
        r = random(min(campoY, -1), max(campoY, 1));
      else if(campo == false)  
        r = random(-1, 1);
        
      sinal = (abs(r))/r;
      
      if( sinal < 0) {         //    sinal negativo -> desloca para cima
        if(j == 0)
          p = new Positivo(par[i][14].p2.x, par[i][14].p2.y, par[i][14], par[i][14].p2, par[i][13], par[i][13].p2);
        else
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i][j-1], par[i][j-1].p2);
      }
      
      else if( sinal > 0){    // sinal positivo -> desloca para baixo
        if(j == 14)
          p = new Positivo(par[i][0].p1.x, par[i][0].p1.y, par[i][0], par[i][0].p1, par[i][1], par[i][1].p1);
        else
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i][j+1], par[i][j+1].p1);
      }
    
    }
    
    else if(p.pproximo.direcao == "VERTICAL"){
        
      if(campo == true)
        r = random(min(campoY, -1), max(campoY,1));
      else if(campo == false)  
        r = random(-1, 1);
        
      sinal = (abs(r))/r;
      
      if( sinal > 0 ){
        if(j == 14)
          j = 0;
        else
          j = j + 1;
      }
      else if( sinal < 0  ){
        if(j == 0)
          j = 14;
        else
          j = j - 1;
      }
      
      if(campo == true)
        r = random(min(campoX, -1), max(campoX, 1));
      else if(campo == false)
        r = random(-1, 1);
        
      sinal = (abs(r))/r;
      
      if( sinal < 0 ){
        if(i == 0){
          if(j == 0)
            p = new Positivo(par[6][j].p2.x, par[6][j].p2.y, par[6][j], par[6][j].p2, par[5][j], par[5][j].p2);
          else if(j > 0){
            if( j % 2 == 1)
              p = new Positivo(par[6][j].p2.x, par[6][j].p2.y, par[6][j], par[6][j].p2, par[5][j - 1], par[5][j - 1].p2);
            else
              p = new Positivo(par[6][j].p2.x, par[6][j].p2.y, par[6][j], par[6][j].p2, par[6][j - 1], par[6][j - 1].p2);
              
          }
            
        }
        else      
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i - 1][j], par[i - 1][j].p2);
      }
      else if( sinal > 0 ){
        if(i == 7)
          {
            if(j == 14)
              p = new Positivo(par[0][j].p1.x, par[0][j].p1.y, par[0][j], par[0][j].p1, par[1][j - 1], par[1][j - 1].p1);
            else if(j < 14)              
              p = new Positivo(par[0][j].p1.x, par[0][j].p1.y, par[0][j], par[0][j].p1, par[1][j + 1], par[1][j + 1].p1);
          }
        else  
          p = new Positivo(p.proximo.x, p.proximo.y, p.pproximo, p.proximo, par[i][j], par[i][j].p1);
      }
    }
  }
     
  p.desloca();
}

//desenha a setinha que indica o sentido do campo elétrico


void desenhaCampo(float x, float y){
  float campoX = mouseX - /*width/2;*/ par[4][9].xpos + PARAMETRO/2;
  float campoY = mouseY - /*height/2;*/ par[4][9].ypos;
  
  //nova origem: centro da seta
  pushMatrix();
  translate(x, y);
  //translate(17*width/20, par[4][9].ypos);
  
  //texto
  textFont(fatomo, 15);
  textAlign(CENTER);
  text("Campo Elétrico", 0, -width/10);
  
  
  
  //desenhamos a seta de sentido, se houver movimento
  if(roda && campo){
    
    strokeWeight(4);
    float mod = sqrt((campoX*campoX + campoY*campoY)/(width*width/4 + height*height/4));
    /*
    line(-40*mod, 30, 40*mod, 30); // representa o módulo do vetor campo elétrico
    */
    
    //rotação
    if( abs(campoX) > .1 && abs(campoY) > .1 ){
      rotate( atan(campoY/campoX) );
      if(campoX < 0)
        rotate(PI);
    }
    
    else if( campoX < -.1 && abs(campoY) < .1 )
      rotate(PI);
  
    else if( abs(campoX) < .1 && abs(campoY) > .1){
      if(campoY > 0)
        rotate(+PI/2);
      else if(campoY < 0)
        rotate(-PI/2);
    }
      stroke(0, 0, 255);
      strokeWeight(1);
      /*
      line(-20, 0, 20, 0);
      line(15, -5, 20, 0); // desenha o sentido do vetor campo
      line(15, 5, 20, 0);
      */
      if(40*sqrt(2)*mod > 5){
        line(-40*mod, 0, 40*mod, 0);
        line(40*mod - 5, -5, 40*mod, 0);          //desenha o vetor campo, com o comprimento correspondendo a seu módulo
        line(40*mod - 5, 5, 40*mod, 0);
      }
      else
        ellipse(0, 0, PARAMETRO/10, PARAMETRO/10);
    }
    
  //caso contrário, desenhamos apenas uma bola
  else {
    ellipse(0, 0, PARAMETRO/10, PARAMETRO/10);
  }
  
  popMatrix();
}

void botaoDisplay(){
  rectMode(CENTER);
  textFont(fatomo, 12);
  aplicaCampo.display();
  //rectMode(CORNERS);
  textFont(f, 12);
}

void mousePressed(){
  
  /*
  if(roda){  
    
    roda = false; 
    
  for(int i = 0; i < 8; i++)
    for(int j = 0; j < 15; j++){
      if(j % 2 == 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.5), PARAMETRO*(j*.5 + 1.5) , "HORIZONTAL");
      else if(j % 2 != 0)
        par[i][j] = new Par(PARAMETRO*(i + 1.0), PARAMETRO*(j*.5 + 1.5) , "VERTICAL");
      par[i][j].i = i;
      par[i][j].j = j;
  }

  p = new Positivo(par[2][2].p2.x, par[2][2].p2.y, par[2][2], par[2][2].p2, par[3][3], par[3][3].p1);
  }
   
  
  else if(!roda)
    roda = true;
  */
  
  roda = true;
  
  //campo = !campo;
  aplicaCampo.mousePressed();  
  credito.botao.mousePressed();
  credito.display();
}

void mouseReleased(){
  aplicaCampo.mouseReleased();
  
  if(aplicaCampo.situacao == "SELECIONADO"){
    campo = true;
    aplicaCampo.texto = "RETIRAR";
  }
  
  else if(aplicaCampo.situacao == "LIBERADO"){
    campo = false;
    aplicaCampo.texto = "APLICAR";
  }
  credito.botao.mouseReleased();
}
    
  
